---
title: Cache.keys()
slug: Web/API/Cache/keys
tags:
  - API
  - Cache
  - Experimental
  - Method
  - Reference
  - Service Workers
  - ServiceWorker
  - keys
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <strong><code>keys()</code></strong> method of the {{domxref("Cache")}} interface returns a {{jsxref("Promise")}} that resolves to an array of {{domxref("Cache")}} keys.</p>

<p>The requests are returned in the same order that they were inserted.</p>

<div class="note">
<p><strong>Note</strong>: Requests with duplicate URLs but different headers can be returned if their responses have the <code>VARY</code> header set on them.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>cache</em>.keys(<em>request</em>, {<em>options</em>}).then(function(<em>keys</em>) {
  // do something with your array of requests
});
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>request {{optional_inline}}</dt>
 <dd>The {{domxref("Request")}} want to return, if a specific key is desired. This can be a <code>Request</code> object or a URL.</dd>
 <dt>options {{optional_inline}}</dt>
 <dd>An object whose properties control how matching is done in the <code>keys</code> operation. The available options are:
 <ul>
  <li><code>ignoreSearch</code>: A {{jsxref("Boolean")}} that specifies whether the matching process should ignore the query string in the url.  If set to <code>true</code>, the <code>?value=bar</code> part of <code>http://foo.com/?value=bar</code> would be ignored when performing a match. It defaults to <code>false</code>.</li>
  <li><code>ignoreMethod</code>: A {{jsxref("Boolean")}} that, when set to <code>true</code>, prevents matching operations from validating the {{domxref("Request")}} <code>HTTP</code> method (normally only <code>GET</code> and <code>HEAD</code> are allowed.) It defaults to <code>false</code>.</li>
  <li><code>ignoreVary</code>: A {{jsxref("Boolean")}} that, when set to <code>true,</code> tells the matching operation not to perform <code>VARY</code> header matching.  In other words, if the URL matches you will get a match regardless of  whether the {{domxref("Response")}} object has a <code>VARY</code> header. It defaults to <code>false</code>.</li>
  <li><code>cacheName</code>: A {{domxref("DOMString")}} that represents a specific cache to search within. Note that this option is ignored by <code>Cache.keys()</code>.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves to an array of {{domxref("Cache")}} keys.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">caches.open('v1').then(function(cache) {
  cache.keys().then(function(keys) {
    keys.forEach(function(request, index, array) {
      cache.delete(request);
    });
  });
})</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#cache-keys', 'Cache: keys')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Cache.keys")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li>{{domxref("Cache")}}</li>
 <li>{{domxref("WorkerGlobalScope.caches")}}</li>
</ul>
